

CITFS(1)             FNORDADEL BBS SOFTWARE              CITFS(1)

NAME
     citfs.tos - spool Fnordadel sendfiles and file requests

SYNOPSIS
     citfs -s <system> <file1> ... [fileN]
     citfs -r <system> <room> <targetdir> <file1> ... [fileN]

DESCRIPTION
     Citfs allows you to queue up network file sends and requests
     without having to bring up Fnordadel.  It takes all needed
     parameters from the command line, so it can be used in non-
     interactive situations like from a batch file or whatever.

     Citfs expects to be run from the directory containing
     ctdltabl.sys.

OPTIONS
     -s   Do a sendfile.

     -r   Do a file request.

     <system>
          The nodename of the system in question.  If the
          nodename has space characters in it, substitute '_'
          (underscore) characters for the spaces.

     <room>
          This option is used only with a file request.  It
          specfies the name of the room on the other system from
          which to request files.

     <targetdir>
          This is the path-spec of a directory on your storage
          device in which to put the received files.  This, too,
          is only used with '-r' (file request).

     <file1> ... [fileN]
          One or more filenames to send or request.  Wildcards
          may be passed in (like "*.c"); make sure if you want to
          pass a wildcard to citfs and you are using a shell
          which might expand wildcards itself that you quote the
          wildcard filename, e.g.

          citfs -s RT 'file*.c'

NOTES
     You must specify only ONE of -s or -r options, obviously.

BUGS
     If the <room> has spaces in it, citfs will currently mis-
     parse the command line and produce erroneous results.

FILES
     citfs.tos          The file send & request spooler.
     #netdir\{nn}.nfs   Send/request queue for net node 'nn'.
     ctdltabl.sys       Tables file.

SEE ALSO
     The Fnordadel Reference Manual

AUTHOR
     Citfs was written by Adrian Ashley for Fnordadel.
