

MAKEZT(1)            FNORDADEL BBS SOFTWARE             MAKEZT(1)

NAME
     makezt.tos - make the network loop zap table

SYNOPSIS
     makezt

DESCRIPTION
     Makezt creates the Fnordadel network loop zap table from
     scratch, writing over top of any zap information that may
     already have existed.  The zap table's purpose is to refuse
     replicated messages that come in from nodes anywhere on the
     network.  A message is defined as being a replicate if the
     date in its header is earlier than the date of the latest
     message received from the same node, in the same room, AND
     the message's original ID# is less than the message ID# of
     the latest message received.

     Makezt will scan the entire message base to build the zap
     table, after which time citadel.tos will maintain it
     automatically (if you invoke citadel with the '+zap' option,
     or if you have '#define zaploops' in your ctdlcnfg.sys).

     Makezt expects to be run from the directory containing
     ctdltabl.sys.

OPTIONS
     None.

NOTES
     As makezt runs, it will display a lot of information that
     you can safely ignore.  If you ever need to see what is in
     the zap table, use scanzt.tos.

     If the message base contains no network messages from any
     other node, makezt will not do anything.

FILES
     makezt.tos             The zap table creator.
     #netdir\ctdlloop.zap   The zap table.
     #msgdir\ctdlmsg.sys    The message file.
     ctdltabl.sys           The system table file.

SEE ALSO
     scanzt.man   Man page for scanzt.tos.
     The Fnordadel Reference Manual

AUTHORS
     David Parsons wrote makezt.tos for STadel.

     Adrian Ashley and Royce Howland did precious little to it
     for the Fnordadel project.
